package com.subd.subd.Controllers;

import com.subd.subd.Models.PickUpPoint;
import com.subd.subd.Services.PickUpPointService;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
public class PickUpPointController {
    private final PickUpPointService PickUpPointService;
    public PickUpPointController(PickUpPointService PickUpPointService) {
        this.PickUpPointService = PickUpPointService;
    }
    @GetMapping("/{id}")
    public PickUpPoint getPickUpPoint(@PathVariable Long id) {
        return PickUpPointService.findPickUpPoint(id);
    }
    @GetMapping
    public List<PickUpPoint> getPickUpPoints() {
        return PickUpPointService.findAllPickUpPoints();
    }
    @PostMapping
    public PickUpPoint createPickUpPoint(@RequestBody PickUpPoint PickUpPoint) {
        return PickUpPointService.addPickUpPoint(PickUpPoint.getAddress());
    }
    @PutMapping("/{id}")
    public PickUpPoint updatePickUpPoint(@PathVariable Long id, @RequestBody PickUpPoint PickUpPoint) {
        return PickUpPointService.updatePickUpPoint(id, PickUpPoint.getAddress());
    }
    @DeleteMapping("/{id}")
    public PickUpPoint deletePickUpPoint(@PathVariable Long id) {
        return PickUpPointService.deletePickUpPoint(id);
    }
}
