package com.subd.subd.Models;

import jakarta.annotation.Nullable;
import jakarta.persistence.*;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

@Entity
@Table(name = "Client")
public class Client {
    @Id
    @GeneratedValue
    private Long id;
    private String name;
    private String phone;
    @Nullable
    private String email;
    @OneToMany(cascade = {CascadeType.MERGE})
    private List<Order> orders;
    Client() {}
    Client(String name, String phone, @Nullable String email) {
        this.name = name;
        this.phone = phone;
        this.email = email;
    }
    public Long getId() { return this.id; }
    public void setId(Long id) { this.id = id; }
    public String getName() { return this.name; }
    public void setName(String name) { this.name = name; }
    public String getPhone() { return this.phone; }
    public void setPhone(String phone) { this.phone = phone; }
    @Nullable
    public String getEmail() { return this.email; }
    public void setEmail(@Nullable String email) { this.email = email; }
    public List<Order> getOrders() {
        return orders;
    }
    public void addOrder(Order order){
        if  (orders == null){
            this.orders = new ArrayList<>();
        }
        if (!orders.contains(order)) {
            this.orders.add(order);
            order.setClient(this);
        }
    }
    public void removeOrder(Order order){
        if (orders.contains(order))
            this.orders.remove(order);
    }
    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;
        if (!(o instanceof Client))
            return false;
        Client client = (Client) o;
        return Objects.equals(this.id, client.id) &&
                Objects.equals(this.name, client.name) &&
                Objects.equals(this.phone, client.phone) &&
                Objects.equals(this.email, client.email);
    }
    @Override
    public int hashCode() {
        return Objects.hash(this.id, this.name, this.phone, this.email);
    }
    @Override
    public String toString() {
        return "Client{" + "id=" + this.id +
                ", name='" + this.name + '\'' +
                ", phone='" + this.phone + '\'' +
                ", email='" + this.email + '\'' +
                '}';
    }
}
